"""metanav -- NavigationFolder"""

__author__  = 'Brian Gershon <briang@webcollective.coop>'
__docformat__ = 'plaintext'

try:
    from Products.LinguaPlone.public import *
except ImportError:
    from Products.Archetypes.public import *

## General
from DateTime import DateTime

## Zope
from zope.interface import implements

## CMF
from Products.CMFCore.permissions import ModifyPortalContent

## ATCT + Friends
from Products.ATContentTypes.content.folder import ATFolderSchema, ATFolder
from Products.ATContentTypes.content.base import registerATCT
from Products.ATContentTypes.content.schemata import finalizeATCTSchema

##Archetypes
#from Products.Archetypes import atapi
#from Products.Archetypes.public import DisplayList

## Product
from Products.metanav.interfaces import INavigationFolder
from Products.metanav.config import PROJECTNAME


NavigationFolderSchema = ATFolderSchema.copy() + Schema((
    
    StringField(
        name='summary',
        widget=StringWidget
        (
            label="Summary",
            description="Brief 5-10 word summary",
        ),
    ),

    StringField(
        name='placement',
        widget=SelectionWidget(
            label="Navigation Placement",
            description="Where should this top-level navigation be placed?  This field has no effect if set for lower-level navigation folders",
        ),
        vocabulary=DisplayList((
            ('top','Top'),
            ('side','Side'),
        )),
        default='top',
    ),

))

finalizeATCTSchema(NavigationFolderSchema)

class NavigationFolder(ATFolder):
    """A Navigation Folder"""
    implements(INavigationFolder)
    __implements__ = (getattr(ATFolder,'__implements__',()),)
    
    schema         =  NavigationFolderSchema
    
    _at_rename_after_creation = True

    suppl_views = ()
    
    typeDescription= """A Navigation Folder"""

registerATCT(NavigationFolder, PROJECTNAME)
